]> git.phdru.name Git - dotfiles.git/blob - .shellrc
.fvwmrc: Change big terminal size
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60
61 OPS1="$OPS1\\$"
62 PS1="$OPS1 "
63
64
65 if test -n "$BASH_VERSION"; then
66    [ "`type -t ls`" = alias ] && unalias ls
67    [ "`type -t ll`" = alias ] && unalias ll
68    [ "`type -t mc`" = alias ] && unalias mc
69
70    back() { cd - "$@"; }
71    functions() { typeset -f "$@"; }
72    j() { jobs; }
73
74    has_completion() { return 0; }
75    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
76       if [ "$SHELL" = /bin/bash ]; then
77          if [ -d /usr/share/bash-completion -a -f /usr/share/bash-completion/bash_completion ]; then
78             . /usr/share/bash-completion/bash_completion
79             has_completion() { [ -r /usr/share/bash-completion/completions/$1 ]; }
80          elif [ -f /etc/bash_completion ]; then
81             . /etc/bash_completion
82             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
83          elif [ -d /etc/bash_completion.d ]; then
84             for _compf in /etc/bash_completion.d/*; do
85                . $_compf
86             done
87             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
88          fi
89       elif [ "$SHELL" = /usr/local/bin/bash ]; then
90          if [ -d /usr/local/etc/bash_completion.d ]; then
91             for _compf in /usr/local/etc/bash_completion.d/*; do
92                . $_compf
93             done
94             has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
95          fi
96       else
97          echo "Unknown OS type, cannot source bash_completion" >&2
98       fi
99    fi
100
101    for cmd in builtin cgmem_nice command dbus-launch exec \
102       killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
103       time whence whereis which xargs; do
104          ! has_completion $cmd && complete -o default -A command $cmd
105    done
106
107    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
108       telnet t tt \
109       tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
110       whois wd wget wget-download wget-m wget-wrapper ww; do
111          ! has_completion $cmd && complete -A hostname $cmd
112    done
113
114    for cmd in distribute ftp lftp r rsync \
115       s scp ssh smbclient tcpdump tshark wireshark; do
116          ! has_completion $cmd && complete -o default -A hostname $cmd
117    done
118
119    if [ -d "$HOME"/.bash_completion.d ]; then
120       for _compf in "$HOME"/.bash_completion.d/*; do
121          . $_compf
122       done
123    fi
124
125    delegate_completion() {
126       local prog programs
127       prog=$1
128       if has_completion $prog; then
129          shift
130          programs="$@"
131          eval "_${prog}_completion_loader() {
132             _completion_loader $prog
133             complete -o nospace -F _$prog $programs
134             unset _${prog}_completion_loader
135             return 124
136          }"
137          complete -F _${prog}_completion_loader $programs
138       fi
139    }
140
141    delegate_completion make m
142    delegate_completion ping p
143    delegate_completion rsync r rsync_cgmn rsync_cgmn_recode
144    delegate_completion ssh s
145    delegate_completion wget wget-m wget-wrapper ww
146
147    unset has_completion delegate_completion
148
149    complete -A job bg fg j jobs wait
150    complete -A variable -A function unset
151
152    if [ -d "$HOME/lib/config" ]; then
153       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
154    fi
155    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
156
157    #if type -p pip >/dev/null 2>&1; then
158    #   eval "`pip completion --bash`"
159    #   rm -rf /tmp/pip_build_"$USER"
160    #fi
161
162    #if which pyenv >/dev/null 2>&1; then
163    #   eval "`pyenv init -`"
164    #   eval "`pyenv virtualenv-init -`"
165    #fi
166
167    . virtualenvwrapper_lazy.sh 2>/dev/null
168
169    if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
170       . "$VIRTUAL_ENV/bin/activate"
171    fi
172
173    # Clean up python virtual environment on exit
174    # See https://virtualenvwrapper.readthedocs.io/en/latest/tips.html#clean-up-environments-on-exit
175
176    trap '[ "$VIRTUAL_ENV" ] && deactivate' EXIT
177
178 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
179    back() { cd - "$@"; }
180    j() { jobs; }
181 fi
182
183
184 # clear screen and history, logout
185 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
186
187
188 if test -x /usr/bin/git >/dev/null 2>&1; then
189    # chdir to a directory
190    cdgitpath() {
191       if [ $# -ne 1 ]; then
192          echo "Usage: cdgitpath path_key" >&2
193          return 1
194       fi
195
196       path_key="$1"
197       if [ -z "$path_key" ]; then
198          echo "Usage: cdgitpath path_key" >&2
199          return 1
200       fi
201
202       path_url="`git config --get --path $path_key`"
203       if echo "$path_url" | grep -q '^file:/'; then
204          path_url="`echo \"$path_url\" | sed 's@^file:/\+@/@'`"
205       fi
206       cd "$path_url"
207    }
208
209    # chdir to a remote's directory (if the remote is on the local FS)
210    cdremote() {
211       if [ $# -gt 1 ]; then
212          echo "Usage: cdremote [remote_name]" >&2
213          return 1
214       fi
215
216       if [ -z "$1" ]; then
217          branch="`git rev-parse --abbrev-ref HEAD`"
218          remote="`git config --get branch.$branch.remote`"
219       else
220          remote="$1"
221       fi
222
223       if [ -n "$remote" ] && git config --get remote.$remote.url |
224             grep -q '^\(file:/\|/\|\.\./\)'; then # (file:/ or / or ../ at the beginning)
225          cdgitpath remote.$remote.url
226       else
227
228          if [ -n "$1" ]; then
229             echo "Cannot find directory for remote $1" >&2
230             echo "Usage: cdremote [remote_name]" >&2
231             return 1
232          fi
233
234          if test -n "$BASH_VERSION"; then
235             _list_remotes '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
236             if [ ${#GIT_REMOTES[*]} -eq 1 ]; then
237                remote=${GIT_REMOTES[0]}
238                unset GIT_REMOTES
239                cdgitpath remote.$remote.url
240             else
241                unset GIT_REMOTES
242                echo "Cannot find directory for any remote" >&2
243                echo "Usage: cdremote [remote_name]" >&2
244                return 1
245             fi
246          else
247             echo "Cannot find directory for remote $1" >&2
248             echo "Usage: cdremote [remote_name]" >&2
249             return 1
250          fi
251       fi
252    }
253
254    if test -n "$BASH_VERSION"; then
255       # completion for aliases in global .gitconfig
256
257       # fixup rbi rbia rbiap rbip - do refs name completion
258       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
259       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
260       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
261       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
262       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
263       #
264       # push-to-all-remotes - do branch name completion
265       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
266
267       _cdgitpath_complete() {
268          local cur="${COMP_WORDS[COMP_CWORD]}"
269          COMPREPLY=(`compgen -W "$(__git_config_get_set_variables)" -- "$cur"`)
270       }
271
272       _git_open() {
273          _cdgitpath_complete
274       }
275
276       complete -F _cdgitpath_complete cdgitpath git-open
277
278       # list remotes with URLs matching a regexp
279       _list_remotes() {
280          if [ $# -ne 1 ]; then
281             echo "Usage: _list_remotes remote_regexp" >&2
282             return 1
283          fi
284          declare -ag GIT_REMOTES=()
285          local remote
286          for remote in `git remote`; do
287             if git config --get remote.$remote.url | grep -q "$1"; then
288                GIT_REMOTES+=($remote)
289             fi
290          done
291       }
292
293       # completion for cdremote and git-open-remote - list remotes with a pattern
294       _list_remotes_completion() {
295          local cur="${COMP_WORDS[COMP_CWORD]}"
296          _list_remotes "$1"
297          COMPREPLY=(`compgen -W "${GIT_REMOTES[*]}" -- "$cur"`)
298          unset GIT_REMOTES
299       }
300
301       # completion for cdremote - list remotes with directories as URLs
302       _cdremote_complete() {
303          _list_remotes_completion '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
304          if [ ${#COMPREPLY[*]} -eq 0 ]; then
305             _list_remotes_completion .
306          fi
307       }
308
309       complete -F _cdremote_complete cdremote
310
311       # completion for git-open-remote - list remotes with http(s) URLs
312       _git_open_remote() {
313          _list_remotes_completion '^http\(s\)\?://'
314          if [ ${#COMPREPLY[*]} -eq 0 ]; then
315             _list_remotes_completion .
316          fi
317       }
318
319       complete -F _git_open_remote git-open-remote
320    fi
321 fi
322
323
324 include() {
325    cfg="$1"
326    if [ -f "./$cfg" -a -r "./$cfg" ]; then
327       echo "Reading config file \`$cfg'" 1>&2
328       . "./$cfg"
329    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
330       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
331       . "$HOME/lib/config/$cfg"
332    else
333       echo "Cannot find config file \`$cfg'" 1>&2
334    fi
335 }
336
337
338 mc() {
339    if test -n "$BASH_VERSION"; then
340       MC_SAVE_OPS1="$OPS1"
341       OPS1="\u@\h "
342    fi
343
344    if [ -n "$SLOWTERM" ]; then
345       MC_SLOW="--slow"
346    fi
347
348    case "$TERM" in
349       screen*) # screen, screen.rxvt
350          MC_XTERM="-x"
351       ;;
352    esac
353
354    #TMPDIR="$HOME"/tmp
355    #export TMPDIR
356
357    MC_FOUND=NO
358
359    for wrapper in \
360          /usr/local/share/mc/bin/mc-wrapper.sh \
361          /usr/local/libexec/mc/mc-wrapper.sh \
362          /usr/share/mc/bin/mc-wrapper.sh; do
363       if [ -r $wrapper ]; then
364          . $wrapper $MC_SLOW $MC_XTERM "$@"
365          rc=$?
366          MC_FOUND=YES
367          break
368       fi
369    done
370
371    if [ $MC_FOUND = NO ]; then
372       for mc in /usr/local/bin/mc /usr/bin/mc; do
373          if [ -x $mc ]; then
374             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
375             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
376                MC_TMP_DIR="${TMPDIR-/tmp}"
377             fi
378             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
379             mc_type="`mc_type.py $mc`"
380             if [ "$mc_type" = old ]; then
381                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
382             elif [ "$mc_type" = new ]; then
383                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
384             else
385                continue
386             fi
387             rc=$?
388             MC_FOUND=YES
389             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
390             break
391          fi
392       done
393    fi
394
395    if [ $MC_FOUND = NO ]; then
396       echo "Cannot find mc-wrapper.sh or mc" >&2
397       rc=1
398    fi
399
400    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
401    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SLOW MC_TMP_DIR MC_XTERM
402
403    return $rc
404 }
405
406
407 mkcd() {
408    if [ $# -ne 1 ]; then
409       echo "Usage: mkcd directory_name" >&2
410    elif [ -d "$1" ]; then
411       cd "$1"
412    elif [ -e "$1" ]; then
413       echo "Error: $1 is a file" >&2
414    else
415       mkdir -p "$1" && cd "$1"
416    fi
417 }
418
419
420 if which tmux >/dev/null 2>&1; then
421    tmux() {
422       case "$TERM" in
423          rxvt)
424             TERM=rxvt-unicode command tmux "$@"
425          ;;
426
427          *)
428             command tmux "$@"
429          ;;
430       esac
431    }
432 fi
433
434
435 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
436    X() { startx >> .Xserver.log 2>&1; cyr; rm -f .Xauthority; }
437 fi
438
439 x() { exit; }